# -*- coding: utf-8 -*-
"""
Created on Sun Oct  6 23:10:40 2019

@author: patrick
"""
import numpy as np
import random
import time
class game:
    
    # memory stores the experience of each player
    # for the pickClever algorithm
    memoryClever=[[0]*19683,[0]*19683]
    cleverThreshold=20
    
    # memory stores the MiniMax solutions for each
    #event in the tree
    memoryMiniMax=[[0]*19683,[0]*19683]
    visitedMiniMax=[[0]*19683,[0]*19683]
    isMiniMaxTable=False
    

###############################################
#
#   Numbers for the squares
#
#   0 | 1 | 2
#   ---------
#   3 | 4 | 5
#   ---------
#   6 | 7 | 8
#
###############################################

        
    def play(self,strat):
        F=np.array([[0,0,0],[0,0,0],[0,0,0]])
        # left=list of squares that can be picked
        left=[i for i in range(0,9)]
        # turn=number of player who does the first (or next) turn
        turn=random.randint(1,2)
        won=0
        #mem stores the moves for each player in this round
        memP1=[]
        memP2=[]
        #play the game
        while(won==0 and len(left)>0):
            #start = time.time()
        
            #DEBUGGING
            #print('Player',turn,'picks')
        
            # pick your choice
            if(strat[turn-1]=='clever'):
                pick=self.pickClever(turn,left,F)
            elif(strat[turn-1]=='montecarlo'):
                pick=self.pickMonteCarlo(turn,left,F)
            elif(strat[turn-1]=='minimax'):        
                if not self.isMiniMaxTable:
                    start = time.time()
                    self.createMiniMaxTable()
                    self.isMiniMaxTable=True
                    end = time.time()
                    print("Building MiniMax Table:","{:.4f}".format(end-start),"s")             
                #if it's the first turn, pick one of the corners
                if len(left)==9:
                    pick=random.choice([0,2,6,8])
                else:
                    #pick=self.pickMiniMax(turn,left,F)
                    pick=self.pickMiniMaxTable(turn,left,F)
            else:
                pick=self.pickRandom(turn,left,F)
            #keep left list updated
            left.remove(pick)
            F=place(pick,F,turn)
            
            #DEBUGGING
            #print(F)
            
            #store move for the clever-algorithm
            f=np.reshape(F,9)
            n=ter2dec(f)
            if turn==1:
                memP1.append(n)
            else:
                memP2.append(n)
            #next player
            turn=turn%2+1

            won=haswon(F)
        if(strat[0]=='clever' or strat[1]=='clever'):
            self.storeClever(won,memP1,memP2)
        #print(turn,pick,won)
        #print(F)
        #end = time.time()
        #print("Turn:","{:.4f}".format(end-start),"s")
        return(F,won)


    #creates a list of all possible game situations
    #if player t starts the game
    #Q[i] gives a list of all situations after i turns
    def createMiniMaxTable(self):
        for t in [1,2]:
            turn=t
            #at the beginning
            Q=[[0,0,0,0,0,0,0,0,0]]
            #simulate 9 rounds
            for r in range(1,10):
                q=[]
                #load all possibilites of the latest round
                for l in Q:
                    left=[]
                    for i in range(0,9):
                        if l[i]==0:
                            left.append(i)
                    for i in left:
                        a=list.copy(l)
                        a[i]=turn
                        n=ter2dec(a)
                        if self.visitedMiniMax[turn-1][n]==0:
                            if haswon(reshape(a))==0:
                                q.append(a)
                                self.visitedMiniMax[turn-1][n]=r
                                if r==9:
                                    self.memoryMiniMax[turn-1][n]=0
                            else:
                                self.memoryMiniMax[turn-1][n]=turn
                                self.visitedMiniMax[turn-1][n]=-1
                Q=q
                turn=turn%2+1
        #Now the situations with 9 turns have been evaluated
        #we iteratively evaluate situations with 8,7,6,... turns
        R=[8,7,6,5,4,3,2,1]
        for r in R:
            for turn in [1,2]:
                search=True
                #look for situations with visited-status r
                while(search):
                    if r in self.visitedMiniMax[turn-1]:
                        i=self.visitedMiniMax[turn-1].index(r)
                        a=dec2ter(i)
                        T=reshape(a)
                        evaluate=[]
                        left=[]
                        #which choices are left in situation a
                        for k in range(0,9):
                            if a[k]==0:
                                left.append(k)
                        #now pick all possible choices for the
                        #other player and evaluate
                        t=turn%2+1
                        for k in left:
                            F=place(k,T,t)
                            n=ter2dec(reshape(F))
                            ev=self.memoryMiniMax[t-1][n]
                            evaluate.append(ev)
                        #if the other player can win, store that
                        #information in memory
                        if t in evaluate:
                            self.memoryMiniMax[turn-1][i]=t
                        elif 0 in evaluate:
                            self.memoryMiniMax[turn-1][i]=0
                        else:
                            self.memoryMiniMax[turn-1][i]=turn
                        self.visitedMiniMax[turn-1][i]=-1
                    else:
                        search=False
        
        
    #stores the memory for the pickClever algorithm
    def storeClever(self,won,memP1,memP2):
        for i in memP1:
            self.memoryClever[0][i]+=(won+1)%3-1
        for i in memP2:
            self.memoryClever[1][i]-=(won+1)%3-1

    def forgetClever(self):
        memoryClever=[[0]*19683,[0]*19683]


    def pickRandom(self,turn,left,F):
        pick=random.choice(left)
        return pick


    def iterationMiniMax(self,turn,left,F):
        rating=[]
        feedback=0
        for i in left:
            l=list.copy(left)
            l.remove(i)
            T=np.copy(F)
            row=i//3
            col=i%3
            T[row,col]=turn
            won=haswon(T)
            if(won==0 and len(l)>0):
                rating.append(self.iterationMiniMax(turn%2+1,l,T))
            else:
                rating.append(won)
            if won==turn:
                break
        if turn in rating:
            feedback=turn
        elif 0 in rating:
            feedback=0
        else:
            feedback=turn%2+1
        return feedback
              

    def pickMiniMax(self,turn,left,F):
        pick=0
        win=[]
        draw=[]
        for i in left:
            l=list.copy(left)
            l.remove(i)
            T=place(i,F,turn)
            won=haswon(T)
            if won==turn:
                win.append(i)
                break
            else:
                a=self.iterationMiniMax(turn%2+1,l,T)
                if a==turn:
                    win.append(i)
                elif a==0:
                    draw.append(i)
        if len(win)>0:
            pick=random.choice(win)
        elif len(draw)>0:
            pick=random.choice(draw)
        else:
            pick=random.choice(left)

        #DEBUGGING
        '''
        print('Analysis of player',turn)
        print('Wins:',win)
        print('Draws:',draw)
        '''
        return pick
            
        

    def pickMiniMaxTable(self,turn,left,F):
        win=[]
        draw=[]
        for i in left:
            T=place(i,F,turn)
            n=ter2dec(reshape(T))
            m=self.memoryMiniMax[turn-1][n]
            if m==turn:
                win.append(i)
            elif m==0:
                draw.append(i)
        if len(win)>0:
            pick=random.choice(win)
        elif len(draw)>0:
            pick=random.choice(draw)
        else:
            pick=random.choice(left)
        return pick



    def pickMonteCarlo(self,turn,left,F):
        #store ratings for the possible choices
        rating=[]
        for i in left:
            r=0
            #100 iterations for Monte Carlo
            for j in range(0,10):
                l=list.copy(left)
                T=np.copy(F)
                t=turn
                won=0
                k=0
                while(won==0 and len(l)>0):
                    pick=self.pickRandom(t,l,F)
                    l.remove(pick)
                    row=pick//3
                    col=pick%3
                    T[row,col]=t
                    t=t%2+1
                    won=haswon(T)
                    k+=1
                    if k==3:
                        break
                r+=(won+1)%3-1
            rating.append([i,r])
        if turn==1:
            b=max(rating, key=lambda x: x[1])
        else:
            b=min(rating, key=lambda x: x[1])
        pick=b[0]
        return pick
                

    def pickClever(self,turn,left,F):
        tryall=[]
        #try all possible choices
        for i in left:
            Test=np.copy(F)
            f=np.reshape(Test,9)
            f[i]=turn
            #evaluate possible choice
            n=ter2dec(f)
            tryall.append([i,self.memoryClever[turn-1][n]])

        #find the best strategies
        best=[]
        while(len(tryall)>0):
            b=max(tryall, key=lambda x: x[1])
            best.append(b)
            tryall.remove(b)
            if(best[0][1]>b[1]+self.cleverThreshold):
                break
        # add some noise and find the best again
        for i in best:
            i[1]+=random.randint(0,self.cleverThreshold)
        b=max(best, key=lambda x: x[1])
        pick=b[0]
        
        return pick
        
        
def place(i,F,turn):
    T=np.copy(F)
    row=i//3
    col=i%3
    T[row,col]=turn
    return T
    

def ter2dec(a):
    s=0
    for i in range(0,len(a)):
        s+=a[-i-1]*3**i
    return s
    


def dec2ter(n):
    if n==0:
        a=[0]
    else:
        a=[]
        while(n!=0):
            k=n%3
            a.insert(0,k)
            n=(n-k)//3
    while len(a)<9:
        a.insert(0,0)
    return(a)
    

def reshape(A):
    if len(A)==9:
        M=np.zeros((3,3),dtype=int)
        M[0,:]=A[0:3]
        M[1,:]=A[3:6]
        M[2,:]=A[6:9]
        return M
    elif len(A)==3:
        a=[0]*9
        a[0:3]=A[0,:]
        a[3:6]=A[1,:]
        a[6:9]=A[2,:]
        return a
    else:
        return []
        

def haswon(M):
    if(M[0,:]==[1,1,1]).all():
        return 1
    elif(M[0,:]==[2,2,2]).all():
        return 2
    elif(M[1,:]==[1,1,1]).all():
        return 1
    elif(M[1,:]==[2,2,2]).all():
        return 2
    elif(M[2,:]==[1,1,1]).all():
        return 1
    elif(M[2,:]==[2,2,2]).all():
        return 2
    elif(M[:,0]==[1,1,1]).all():
        return 1
    elif(M[:,0]==[2,2,2]).all():
        return 2
    elif(M[:,1]==[1,1,1]).all():
        return 1
    elif(M[:,1]==[2,2,2]).all():
        return 2
    elif(M[:,2]==[1,1,1]).all():
        return 1
    elif(M[:,2]==[2,2,2]).all():
        return 2
    elif(M[0,0]==M[1,1] and M[1,1]==M[2,2] and M[1,1]!=0):
        return M[1,1]
    elif(M[0,2]==M[1,1] and M[1,1]==M[2,0] and M[1,1]!=0):
        return M[1,1]
    else:
        return 0
        
    